﻿using System;
using System.Collections;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApplication3
{
    class Edge : IComparable
    {
        protected int VertexA;
        protected int VertexB;
        public Edge(int vertexA, int vertexB)
        {
            VertexA = vertexA;
            VertexB = vertexB;
        }
        public int GetVertexA() { return VertexA; }
        public int GetVertexB() { return VertexB; }

        public override string ToString()
        {
            return String.Format("({0},{1})", VertexA, VertexB);
        }

        public int CompareTo(object obj)
        {
            Edge a = (Edge)obj;
            Edge b = (Edge)this;
            if (a.VertexA > b.VertexA)
                return -1;
            if (a.VertexA < b.VertexA)
                return 1;
            if (a.VertexB > b.VertexB)
                return -1;
            if (a.VertexB < b.VertexB)
                return 1;
            return 0;
        }
    }
    class WeightedEdge : Edge
    {
        protected float Weight;
        public WeightedEdge(int vertexA, int vertexB, float weight) : base(vertexA, vertexB)
        {
            Weight = weight;
        }
    }
}
